import { Component, OnInit } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { IonHeader, IonToolbar, IonTitle, IonContent, IonButton, IonTextarea, IonInput, IonBackButton, IonButtons, IonCardContent, IonCardTitle, IonCardHeader, IonCard } from '@ionic/angular/standalone';
import { FmodeChatCompletion, MarkdownPreviewModule } from 'fmode-ng';

@Component({
  selector: 'app-world-setup',
  templateUrl: './world-setup.page.html',
  styleUrls: ['./world-setup.page.scss'],
  standalone: true,
  imports: [
    CommonModule, // 确保 CommonModule 已经导入
    FormsModule,
    IonHeader, IonToolbar, IonTitle, IonContent, IonButton, IonTextarea, IonInput, IonBackButton, IonButtons,
    IonCardContent, IonCardTitle, IonCardHeader, IonCard,
    // 引入fm-markdown-preview组件模块
    MarkdownPreviewModule
  ],
})
export class WorldSetupPage implements OnInit {

  constructor() { }
  ngOnInit() { }

  // 用户输入提示词
  type: string = "东方玄幻";
  typeInput(ev: any) {
    this.type = ev.detail.value;
  }

  // 用户输入提示词
  userPrompt: string = "古代";
  promptInput(ev: any) {
    this.userPrompt = ev.detail.value;
  }

  // 属性：组件内用于展示消息内容的变量
  responseMsg: any = "";

  // 方法：实例化completion对象，传入消息数组，并订阅生成的可观察对象。
  isComplete: boolean = false; // 定义完成状态属性，用来标记是否补全完成
  sendMessage() {
    console.log("create");

    let PromptTemplate = `
    您作为一名专业的${this.type}小说作者，请您根据用户提供的期望描述，给出一个世界架构设定。
    以下是用户的口述：${this.userPrompt}
    `;

    let completion = new FmodeChatCompletion([
      { role: "system", content: "" },
      { role: "user", content: PromptTemplate }
    ]);
    completion.sendCompletion().subscribe((message: any) => {
      // 打印消息体
      console.log(message.content);
      // 赋值消息内容给组件内属性
      this.responseMsg = message.content;
      if (message?.complete) { // 判断message为完成状态，则设置isComplete为完成
        this.isComplete = true;
      }
    });
  }

  // 复制到剪贴板
  copyToClipboard() {
    const textarea = document.createElement('textarea');
    textarea.value = this.responseMsg;
    document.body.appendChild(textarea);
    textarea.select();
    document.execCommand('copy');
    document.body.removeChild(textarea);
    alert('内容已复制到剪贴板');
  }
}
